// BASED ON:	Fear No Evil (Last human campagin mission)
//------------------------------------------------------------------------------

$missionName = "DM_Plutonium";

exec("multiplayerStdLib.cs");
exec("DMstdLib.cs");

function player::onAdd(%this)
{
   say(%this, 0, "Welcome to DM_Plutonium!  This map designed by ']['mJ.  This and other maps are available at http://www6.50megs.com/temujin.  At this site you will also find Temujin's skin collections and training manual.");
}

function setDefaultMissionOptions()
{
	$server::TeamPlay = false;
	$server::AllowDeathmatch = false;
	$server::AllowTeamPlay = true;	

   // what can the client choose for a team
	$server::AllowTeamRed = true;
	$server::AllowTeamBlue = true;
	$server::AllowTeamYellow = false;
	$server::AllowTeamPurple = false;

   // what can the server admin choose for available teams
   $server::disableTeamRed = false;
   $server::disableTeamBlue = false;
   $server::disableTeamYellow = true;
   $server::disableTeamPurple = true;
}

// move the map
$server::HudMapViewOffsetX = -150;
$server::HudMapViewOffsetY = -1750;

//-----------------------------------------------------------------------------

function onMissionStart()
{
	plutoSounds();
}

function onMissionLoad(){
   cdAudioCycle("Purge", "Terror", "Watching"); 
}

// ELECTRIC FENCE...

function BlueFence::trigger::OnEnter(%this, %object)
{
      healObject(%object, -10000);
	healObject(%object, -10000);
	healObject(%object, -10000);
	healObject(%object, -10000);
	healObject(%object, -10000);
      say("everybody", 0, getHudName(%object) @ " has been zapped by the blue laser fence!","sfx_electrical_bzzt.WAV");
}

function RedFence::trigger::OnEnter(%this, %object)
{
      healObject(%object, -10000);
	healObject(%object, -10000);
	healObject(%object, -10000);
	healObject(%object, -10000);
	healObject(%object, -10000);
      say("everybody", 0, getHudName(%object) @ " has been zapped by the red laser fence!","sfx_electrical_bzzt.WAV");
}

// Instant Heal/Reload...

function Fire::trigger::onEnter(%this, %object) 
{
      %player = playerManager::vehicleIdToPlayerNum(%object);
      say(%player, 0, "explosionlarge.WAV");
}

function Fire::trigger::onContact(%this, %object) 
{
      %player = playerManager::vehicleIdToPlayerNum(%object);
	Zen::work(%this, %object, 1500, 50, 0, false);
}

//-----------------------------------------------------------------------------
// PadLift code...

function BluePad1::trigger::onEnter(%this, %object) 
{
	LiftToPad(%object, 650, 243, 333, -2360, -2300);
}

function BluePad2::trigger::onEnter(%this, %object) 
{
	LiftToPad(%object, 550, -65, 25, -2347, -2292);
}

function BluePad3::trigger::onEnter(%this, %object) 
{
	LiftToPad(%object, 900, -65, -155, -3000, -3050);
}

function RedPad1::trigger::onEnter(%this, %object) 
{
	LiftToPad(%object, 850, -595, -555, -1740, -1780);
}

function RedPad2::trigger::onEnter(%this, %object) 
{
	LiftToPad(%object, 850, 575, 645, -1390, -1365);
}

function RedPad3::trigger::onEnter(%this, %object) 
{
	LiftToPad(%object, 900, 225, 285, -485, -550);
}

function LiftToPad(%object, %height, %X1, %X2, %Y1, %Y2)
{
      %xnow = getPosition(%object,x);
	%ynow = getPosition(%object,y);

      %xend = randomInt( %X1, %X2 );
	%yend = randomInt( %Y1, %Y2 );

      %xmid = ( %xnow + %xend ) / 2;
	%ymid = ( %ynow + %yend ) / 2;

 	%a = 0.19 * %height;
	schedule( "raiseZ("@%object@","@%a@","@%xnow@","@%ynow@");", 0.1);

	%b = 0.36 * %height;
	schedule( "raiseZ("@%object@","@%b@","@%xnow@","@%ynow@");", 0.2 );

	%c = 0.51 * %height;
	schedule( "raiseZ("@%object@","@%c@","@%xnow@","@%ynow@");", 0.3 );

	%d = 0.64 * %height;
	schedule( "raiseZ("@%object@","@%d@","@%xnow@","@%ynow@");", 0.4 );

	%e = 0.75 * %height;
	schedule( "raiseZ("@%object@","@%e@","@%xnow@","@%ynow@");", 0.5 );

	%f = 0.84 * %height;
	schedule( "raiseZ("@%object@","@%f@","@%xnow@","@%ynow@");", 0.6 );

	%g = 0.91 * %height;
	schedule( "raiseZ("@%object@","@%g@","@%xnow@","@%ynow@");", 0.7 );

	%h = 0.96 * %height;
	schedule( "raiseZ("@%object@","@%h@","@%xnow@","@%ynow@");", 0.8 );

	%i = 0.99 * %height;
	schedule( "raiseZ("@%object@","@%i@","@%xmid@","@%ymid@");", 0.9 );

	%j = %height;
	schedule( "raiseZ("@%object@","@%j@","@%xend@","@%yend@");", 1.0 );

      %player = playerManager::vehicleIdToPlayerNum(%object);
      say(%player, 0, "teleporter.WAV");
}

function raiseZ(%object, %z, %x, %y)
{
	if(%z < (getTerrainHeight( %x, %y ) + 10) )
  	   %z = getTerrainHeight( %x, %y ) + 10;

	setPosition(%object, %x, %y, %z);
}

//-----------------------------------------------------------------------------
// Trampoline...

function Leap::trigger::OnEnter(%this, %object)
{
      %mass = findTrueMass(%object);
      %height = 650 - (5 * %mass);
	%startX = getPosition(%object,x);
	%startY = getPosition(%object,y);

      %player = playerManager::vehicleIdToPlayerNum(%object);

      say(%player, 0, "sfx_had.WAV");
      schedule( "jump("@%object@","@%height@","@%startX@","@%startY@");", 0.25);
}

function jump(%object, %height, %sX, %sY)
{
      //This fakes the 'speed', allows momentum to carry through...
      //change vars are prevented from being between -1 and 1.

	%start = getPosition(%object,z);

	%chX = 2*(getPosition(%object,x) - %sX);
         if(%chX < 1)
            if(%chX > -1) %chX = 1;
	%chY = 2*(getPosition(%object,y) - %sY);
         if(%chY < 1)
            if(%chY > -1) %chY = 1;

	if(%start > 700) {
		%temp = -0.103 * %height;
		schedule("addZ("@%object@","@%temp@","@%chX@","@%chY@","@%start@");",4.1);

		%temp = -0.21 * %height;
		schedule("addZ("@%object@","@%temp@","@%chX@","@%chY@","@%start@");",4.2);

		%temp = -0.323 * %height;
		schedule("addZ("@%object@","@%temp@","@%chX@","@%chY@","@%start@");",4.3);

		%temp = -0.44 * %height;
		schedule("addZ("@%object@","@%temp@","@%chX@","@%chY@","@%start@");",4.4);

		%temp = -0.563 * %height;
		schedule("addZ("@%object@","@%temp@","@%chX@","@%chY@","@%start@");",4.5);

		%temp = -0.69 * %height;
		schedule("addZ("@%object@","@%temp@","@%chX@","@%chY@","@%start@");",4.6);

		%temp = -0.823 * %height;
		schedule("addZ("@%object@","@%temp@","@%chX@","@%chY@","@%start@");",4.7);

		%temp = -0.96 * %height;
		schedule("addZ("@%object@","@%temp@","@%chX@","@%chY@","@%start@");",4.8);
		}
		
	schedule("addZ("@%object@", 1,"@%chX@","@%chY@","@%start@");",4);

	%temp = 0.098 * %height;
	schedule("addZ("@%object@","@%temp@","@%chX@","@%chY@","@%start@");",0.1);
	schedule("addZ("@%object@","@%temp@","@%chX@","@%chY@","@%start@");",3.9);

	%temp = 0.19 * %height;
	schedule("addZ("@%object@","@%temp@","@%chX@","@%chY@","@%start@");",0.2);
	schedule("addZ("@%object@","@%temp@","@%chX@","@%chY@","@%start@");",3.8);

	%temp = 0.278 * %height;
	schedule("addZ("@%object@","@%temp@","@%chX@","@%chY@","@%start@");",0.3);
	schedule("addZ("@%object@","@%temp@","@%chX@","@%chY@","@%start@");",3.7);

	%temp = 0.36 * %height;
	schedule("addZ("@%object@","@%temp@","@%chX@","@%chY@","@%start@");",0.4);
	schedule("addZ("@%object@","@%temp@","@%chX@","@%chY@","@%start@");",3.6);

	%temp = 0.438 * %height;
	schedule("addZ("@%object@","@%temp@","@%chX@","@%chY@","@%start@");",0.5);
	schedule("addZ("@%object@","@%temp@","@%chX@","@%chY@","@%start@");",3.5);

	%temp = 0.51 * %height;
	schedule("addZ("@%object@","@%temp@","@%chX@","@%chY@","@%start@");",0.6);
	schedule("addZ("@%object@","@%temp@","@%chX@","@%chY@","@%start@");",3.4);

	%temp = 0.578 * %height;
	schedule("addZ("@%object@","@%temp@","@%chX@","@%chY@","@%start@");",0.7);
	schedule("addZ("@%object@","@%temp@","@%chX@","@%chY@","@%start@");",3.3);

	%temp = 0.64 * %height;
	schedule("addZ("@%object@","@%temp@","@%chX@","@%chY@","@%start@");",0.8);
	schedule("addZ("@%object@","@%temp@","@%chX@","@%chY@","@%start@");",3.2);

	%temp = 0.698 * %height;
	schedule("addZ("@%object@","@%temp@","@%chX@","@%chY@","@%start@");",0.9);
	schedule("addZ("@%object@","@%temp@","@%chX@","@%chY@","@%start@");",3.1);

	%temp = 0.75 * %height;
	schedule("addZ("@%object@","@%temp@","@%chX@","@%chY@","@%start@");",1);
	schedule("addZ("@%object@","@%temp@","@%chX@","@%chY@","@%start@");",3);

	%temp = 0.798 * %height;
	schedule("addZ("@%object@","@%temp@","@%chX@","@%chY@","@%start@");",1.1);
	schedule("addZ("@%object@","@%temp@","@%chX@","@%chY@","@%start@");",2.9);

	%temp = 0.84 * %height;
	schedule("addZ("@%object@","@%temp@","@%chX@","@%chY@","@%start@");",1.2);
	schedule("addZ("@%object@","@%temp@","@%chX@","@%chY@","@%start@");",2.8);

	%temp = 0.878 * %height;
	schedule("addZ("@%object@","@%temp@","@%chX@","@%chY@","@%start@");",1.3);
	schedule("addZ("@%object@","@%temp@","@%chX@","@%chY@","@%start@");",2.7);

	%temp = 0.91 * %height;
	schedule("addZ("@%object@","@%temp@","@%chX@","@%chY@","@%start@");",1.4);
	schedule("addZ("@%object@","@%temp@","@%chX@","@%chY@","@%start@");",2.6);

	%temp = 0.938 * %height;
	schedule("addZ("@%object@","@%temp@","@%chX@","@%chY@","@%start@");",1.5);	
	schedule("addZ("@%object@","@%temp@","@%chX@","@%chY@","@%start@");",2.5);

	%temp = 0.96 * %height;
	schedule("addZ("@%object@","@%temp@","@%chX@","@%chY@","@%start@");",1.6);	
	schedule("addZ("@%object@","@%temp@","@%chX@","@%chY@","@%start@");",2.4);

	%temp = 0.978 * %height;
	schedule("addZ("@%object@","@%temp@","@%chX@","@%chY@","@%start@");",1.7);
	schedule("addZ("@%object@","@%temp@","@%chX@","@%chY@","@%start@");",2.3);

	%temp = 0.99 * %height;
	schedule("addZ("@%object@","@%temp@","@%chX@","@%chY@","@%start@");",1.8);
	schedule("addZ("@%object@","@%temp@","@%chX@","@%chY@","@%start@");",2.2);

	%temp = 0.998 * %height;
	schedule("addZ("@%object@","@%temp@","@%chX@","@%chY@","@%start@");",1.9);
	schedule("addZ("@%object@","@%temp@","@%chX@","@%chY@","@%start@");",2.1);

	%temp = %height;
	schedule("addZ("@%object@","@%temp@","@%chX@","@%chY@","@%start@");",2);
}

function addZ(%object, %z, %chX, %chY, %start)
{
	%z += %start;
      %y = getPosition(%object,y) + %chY;
      %x = getPosition(%object,x) + %chX;

	if(%z < (getTerrainHeight( %x, %y ) + 10) )
  	   %z = getTerrainHeight( %x, %y ) + 10;

	setPosition(%object, %x, %y, %z);
}
	
//-----------------------------------------------------------------------------
// Mass Code (thanks to Dungat)...

function findTrueMass(%what)
{
	return (findBaseMass(%what) - getVehicleAvailableMass(%what));
      //getVehicleAvailableMass() gives you the amount of room left, right?
}

function findBaseMass(%what)
{
	%type= getVehicleName(%what);
	if (%type=="Talon") return 30;
	if (%type=="Knight's Talon") return 30;
	if (%type=="Minotaur") return 40;
	if (%type=="Knight's Minotaur") return 40;
	if (%type=="Basilisk") return 50;
	if (%type=="Knight's Basilisk") return 50;
	if (%type=="Apocalpyse") return 60;
	if (%type=="Knight's Apocalypse") return 60;
	if (%type=="Gorgon") return 80;
	if (%type=="Knight's Gorgon") return 80;
	if (%type=="Emancipator") return 40;
	if (%type=="Outrider Emancipator") return 40;
	if (%type=="Olympian") return 75;
	if (%type=="Avenger") return 30;
	if (%type=="Dreadlock") return 45;
	if (%type=="Disrupter") return 55;
	if (%type=="Myrmidon") return 90;
	if (%type=="Paladin") return 60;
	if (%type=="Knight's Disrupter") return 55;
	if (%type=="Knight's Myrmidon") return 90;
	if (%type=="Knight's Paladin") return 60;
	if (%type=="Harabec's Predator") return 60;
	if (%type=="Seeker") return 25;
	if (%type=="Metagen Seeker") return 25;
	if (%type=="Goad") return 35;
	if (%type=="Metagen Goad") return 35;
	if (%type=="Shepherd") return 48;
	if (%type=="Metagen Shepherd") return 48;
	if (%type=="Adjudicator") return 60;
	if (%type=="Platinum Guard Adjudicator") return 60;
	if (%type=="Executioner") return 90;
	if (%type=="Platinum Guard Executioner") return 90;
	if (%type=="Bolo") return 35;
	if (%type=="Recluse") return 40;
	return 0;
}